/*
	BeGEDemo.cpp
	
	Test application for BeOS verion of Graphic Elements
	
	Copyright 1996 by Al Evans. All rights reserved
	
	2/14/96
	
*/

#include "BeGEDemo.h"
#include "GEDemoWindow.h"
#include "GEDemo2Window.h"
#include "GEDemoView.h"


main()
{	
	GEDemoApp *app;

	app = new GEDemoApp();
	app->Run();
	
	delete(app);
	return(0);
}

GEDemoApp::GEDemoApp()
	: BApplication('GEde')
{
	mSmallWind = NULL;
	SetupMenu();
}

void GEDemoApp::ReadyToRun()
{
	GEDemoWindow	*window = new GEDemoWindow();
	
	if (window->LoadScene())
		window->Show();
	else
		PostMessage(B_QUIT_REQUESTED);
	
}

void GEDemoApp::MessageReceived(BMessage *message)
{
	switch (message->what) {
		case MSG_SMALL_WINDOW:
			DoSmallWindow();
			break;
		default:
			BApplication::MessageReceived(message);
			break;
	}
}

bool GEDemoApp::QuitRequested()
{
	if (mSmallWind != NULL) 
		DoSmallWindow();
	return true;
}

void GEDemoApp::MenusWillShow()
{
	Lock();
	BPopUpMenu	*menu = MainMenu();
	BMenuItem	*windowItem = menu->FindItem(MSG_SMALL_WINDOW);
	if (mSmallWind == NULL)
		windowItem->SetLabel("Open reduced window");
	else
		windowItem->SetLabel("Close reduced window");
	Unlock();
}


void GEDemoApp::SetupMenu()
{
	Lock();
	BPopUpMenu	*menu = new BPopUpMenu("", false, false);
	BMenuItem	*item = NULL;
	
	// About
	item = new BMenuItem("About BePNG...", new BMessage(B_ABOUT_REQUESTED));
	item->SetTarget(this);
	menu->AddItem(item);
	
	// Small window -- menu item label set in MenusWillShow()
	item = new BMenuItem("", new BMessage(MSG_SMALL_WINDOW));
	item->SetTarget(this);
	menu->AddItem(item);
	
	// Quit
	item = new BMenuItem("Quit", new BMessage(B_QUIT_REQUESTED));
	item->SetTarget(this);
	menu->AddItem(item);
	
	SetMainMenu(menu);
	Unlock();
}

void GEDemoApp::DoSmallWindow()
{
	if (mSmallWind == NULL) {
		GEDemo2Window *window2 = new GEDemo2Window();
		if (window2->LoadScene()) {
			window2->Show();
			mSmallWind = window2;
		}
		else
			window2->Quit();
	}
	else {
		mSmallWind->Quit();
		mSmallWind = NULL;
	}
}

