/*
	GEDemo2Window.cpp
	
	
	Be Window class for second window of Graphic Elements Demo
	
	Be Window class for reduced-size window of Graphic Elements Demo
	
	Copyright 1996 by Al Evans. All rights reserved.
	
	2/20/96
	
*/

#include "GEDemo2Window.h"
#include "GEDemoView.h"

GEDemo2Window::GEDemo2Window()
		: GEDemoWindow()
{
	Lock();
	// this one is half the size of first window + menu
	ResizeTo(mRefRect.Width() / 2, mRefRect.Height() / 2 + 14);
	MoveBy(mRefRect.Width() - 100, mRefRect.Height() - 50);
	SetTitle("Reduced");
	Unlock();
}

GEDemo2Window::~GEDemo2Window()
{
}

bool GEDemo2Window::QuitRequested()
{
	// Tell the application to close it
	be_app->PostMessage(MSG_SMALL_WINDOW);
	return false;
}

bool GEDemo2Window::LoadScene()
{
	bool ret;
	
	Lock();
	BRect viewRect = mRefRect;
	viewRect.OffsetBy(0, 14);
	mView = new GEDemoView(viewRect, (float) 1/2);
	if (mView == NULL)
		ret = false;
	else {
		AddChild(mView);
		ret = (((GEDemoView *) mView)->InitDemoWorld());
	}
	Unlock();
	return ret;
}

