/*
	GETestView.cpp
	
	GEView for BeGEDemo
	
	Copyright 1996 by Al Evans. All rights reserved.
	
	2/15/96
	
*/

#include "GEDemoView.h"
#include "cannon.h"
#include "grabber.h"
#include "motion.h"
#include "pogo.h"
#include "sign.h"
#include "walk.h"

#define	rBrickPic 200

bool LoadDemoWorld(GEWorldPtr world)
{
	GrafElPtr	bkg = NewBasicPICT(world, 'BKG ', 1, rBrickPic, srcCopy, 0, 0);
	
	if (bkg == NULL) return false;
	if (!LoadCannonScene(world)) return false;
	if (!LoadBalconyScene(world)) return false;
	if (!LoadPogoScene(world)) return false;
	if (!LoadSignScene(world)) return false;
	if (!MakeGrabber(world)) return false;

	return true;
}

GEDemoView::GEDemoView(BRect refFrame, float scale)
	:GEView(refFrame, scale)
{
	mSounds = NULL;
}

GEDemoView::~GEDemoView()
{
	if (mSounds != NULL) {
		mGEWorld->userData = NULL;
		GEDisposeSounds(mSounds);
		mSounds = NULL;
	}
}

bool GEDemoView::InitDemoWorld()
{
	if (!MakeWorld())
		return false;
	if (mSounds == NULL)
		mSounds = GEInitSounds(4);
	mGEWorld->userData = (Ptr) mSounds;
	return (LoadWorld(LoadDemoWorld));
}

void GEDemoView::ActivateGrabber(bool activate)
{
	::ActivateGrabber(mGEWorld, activate);
}

void GEDemoView::ShootCannon()
{
	::ShootCannon(mGEWorld, NULL, sensorOn);
}

bool GEDemoView::GrabberActive()
{
	return ::GrabberActive(mGEWorld);
}

void GEDemoView::GetSignText(char *oldText)
{
	::GetSignText((unsigned char *) oldText);
}

void GEDemoView::SetSignText(const char *newText)
{
	::SetSignText(mGEWorld, (unsigned char *) newText);
}

