/*
	GetTextDialog.h
	
	Dialog class for getting a line of text.
	
	When the OK button is pressed, it sends a MSG_NEW_TEXT message to its parent
	window containing a string labelled 'text'.
	
	Based on -- OK, practically stolen from -- the "Find" dialog in John Norstad's 
	BetterEdit. Thanks, John!
	
	Al Evans
	
	2/21/96
	
*/

#ifndef GETTEXTDIALOG
#define GETTEXTDIALOG

#define MSG_NEW_TEXT 'NTxt'

class GetTextDialog : public BWindow
{
public:
					GetTextDialog(BWindow *parent, const char *title, const char *oldText);
virtual				~GetTextDialog();

protected:
void				MessageReceived(BMessage *msg);
void				MakeTextEntryField(BRect labelRect, const char *label,
										BView *container, const char *name, bool makeFocus, 
										const char *initValue);
BWindow				*mParent;

};


#endif